#TEMPLATE (FieldAndTableList, 'Field and Table List'),FAMILY('ABC')
#!
#! Schoeffler & Rau Datensysteme (c) 1999
#!
#! http://www.schoeffler. biz
#! mailto:info@schoeffler.biz
#!
#!------------------------------------------------------------------------------
#! PROCEDURES Templates
#!------------------------------------------------------------------------------
#! FieldListProcedure
#! TabelListProcedure
#!------------------------------------------------------------------------------
#INCLUDE('Standard.TPW')
#!------------------------------------------------------------------------------


#! ####################################################################################################
#! ####################################################################################################


#PROCEDURE(FieldListProcedure,'Fieldlist Procedure'),WINDOW
%Procedure PROCEDURE(pTable,pField,pPicture,pMode)
#PROTOTYPE ('(*STRING,*STRING,*STRING,BYTE),STRING')
#BUTTON ('&Properties'), AT(10, 30, 180)
  #SHEET
   #TAB ('Fiedlist Options')
     #DISPLAY('')
     #DISPLAY('(c) Schoeffler & Rau Datensysteme')
     #DISPLAY('by Ralf Schoeffler 1999')
     #DISPLAY ('')
     #DISPLAY ('Mode = 0 switch Tables')
     #DISPLAY ('Mode = 1 no switch Tables')
     #DISPLAY ('')
     #PROMPT('Window Operation Mode:',DROP('Use WINDOW setting|Normal|MDI|Modal')),%WindowOperationMode
     #BUTTON ('Exclude Tables'), MULTI(%ExclTables, %ExclTable)
       #PROMPT ('Exclude tables', FROM(%FILE)), %ExclTable, REQ
     #ENDBUTTON
   #ENDTAB
  #ENDSHEET
 #ENDBUTTON

#INSERT(%FileControlInitialize(Clarion))
#AT(%CustomGlobalDeclarations)
  #INSERT(%FileControlSetFlags(Clarion))
#ENDAT
#FOR(%LocalData)
%[20]LocalData %LocalDataStatement
#ENDFOR
l:qTable             QUEUE,PRE()
lqTable:Table          STRING(20)
                     END
l:qField             QUEUE,PRE()
lqField:Field          STRING(32)
lqField:C1             LONG
lqField:C2             LONG
lqField:C3             LONG
lqField:C4             LONG
lqField:Picture        STRING(10)
lqField:Type           STRING(10)
                     END

#WINDOWS
window WINDOW('Fieldlist'),AT(,,255,266),FONT('MS Sans Serif',8,,),SYSTEM,GRAY
       SHEET,AT(1,2,249,262),USE(?Sheet1)
         TAB('Fields'),USE(?Tab1)
           LIST,AT(3,19,104,163),USE(?List1),VSCROLL,FORMAT('20L(2)~Tables~'),FROM(l:qTable)
           LIST,AT(112,19,134,241),USE(?List2),VSCROLL,ALRT(EnterKey),ALRT(MouseLeft2),FORMAT('90L(2)|M*~Field~@s40@32L(2)~Picture~@s10@'), |
               FROM(l:qField)
         END
       END
     END
#ENDWINDOWS

#INSERT(%StandardWindowField)
#GROUP(%StandardWindowField)
#DECLARE(%FirstField)
#DECLARE(%LastField)
#IF(NOT %Window)
  #ERROR(%Procedure & ' Error: No Window Defined!')
  #RETURN
#ENDIF
#INSERT(%StandardWindowGeneration)
#!
#EMBED(%DataSection,'Data Section'),DATA
  CODE
#!-----------------------------------------------------------------------------------------
#EMBED(%StartOfProcedure,'Start of Procedure')
  free(l:qTable)
  free(l:qField)
 #FOR(%File)
   #FIND (%ExclTable, %File)
   #IF (%ExclTable)
     #CYCLE
   #ENDIF
  lqTable:Table = '%File' ; add(l:qTable)
 #ENDFOR
 #EMBED(%EndOfTables,'End of fill Tables Queue')
#!-----------------------------------------------------------------------------------------
#EMBED(%BeforeOpenWindow,'Before Window Open')
  a# = 0
  sort(l:qTable,+lqTable:Table)
  open(%Window)
#EMBED(%AfterOpenWindow,'After open window')
  ! Select entry in List1
  l:qTable = pTable
  get(l:qTable,lqTable:Table)
  select(?List1,pointer(l:qTable))
  do FillQueue
  display()
  accept
    if event() = Event:Accepted then
      if Field() = ?List1 then
        get(l:qTable,choice(?List1))
        do FillQueue
        display()
      end
    end
    if event() = event:alertkey then
      get(l:qField,choice(?List2))
      pTable   = lqTable:Table
      pField   = lqField:Field
      pPicture = lqField:Picture
      a# = 1
      break
    end
  end
  close(%Window)
#EMBED(%BeforeReturn,'Before Return')
  if a# = 1 then
    return(clip(lqTable:Table) &':'& clip(lqField:Field))
  else
    if pTable and pField then
      return(clip(pTable) &':' & clip(pField))
    else
      return('')
    end
  end
#EMBED(%EndOfProcedure,'End of Procedure')

#EMBED(%ProcedureRoutines,'Procedure Routines')
FillQueue Routine
 free(l:qField)
 case lqTable:Table
 #FOR(%File)
   #FIND (%ExclTable, %File)
   #IF (%ExclTable)
     #CYCLE
   #ENDIF
   of '%File'
     #FOR(%Key)
     lqField:Field   = sub('%Key',instring(':','%Key',1,1) + 1, 32)
     lqField:Picture = ''
     lqField:Type    = 'Key'
     do AddQueue
     #ENDFOR
     #FOR(%Field)
     #IF(%FieldType = 'GROUP' or %FieldType = 'END' or (%FieldMemoSize = 8 and %FieldType = 'STRING'))
       #CYCLE
     #ENDIF
     lqField:Field   = '%FieldID'
     lqField:Picture = '%FieldDisplayPicture'
     lqField:Type    = '%FieldType'
     do AddQueue
     #ENDFOR
 #ENDFOR
 #EMBED(%EndOfFillFieldQueue,'End of fill Fieldqueue')
 end

AddQueue Routine
   if lqField:Type = 'Key' then
     lqField:C1 = Color:Blue
     lqField:C2 = -1
     lqField:C3 = COLOR:Aqua
     lqField:C4 = -1
   elsif lqField:Type = 'ULONG' and sub(upper(lqField:Field),1,3)= 'SYS'then
     lqField:C1 = Color:Green
     lqField:C2 = -1
     lqField:C3 = COLOR:Lime
     lqField:C4 = -1
   else
     lqField:C1 = -1
     lqField:C2 = -1
     lqField:C3 = -1
     lqField:C4 = -1
   end
   add(l:qField)

#! ####################################################################################################
#! ####################################################################################################

#PROCEDURE(TabelListProcedure,'Tablelist Procedure'),WINDOW
%Procedure PROCEDURE(pTable)
#PROTOTYPE ('(STRING),STRING')
#BUTTON ('&Properties'), AT(10, 30, 180)
  #SHEET
   #TAB ('Tabel Options')
     #DISPLAY('')
     #DISPLAY('(c) Schoeffler & Rau Datensysteme')
     #DISPLAY('by Ralf Schoeffler 1999')
     #DISPLAY ('')
     #PROMPT('Window Operation Mode:',DROP('Use WINDOW setting|Normal|MDI|Modal')),%WindowOperationMode
     #BUTTON ('Exclude Tables'), MULTI(%ExclTables, %ExclTable)
       #PROMPT ('Exclude tables', FROM(%FILE)), %ExclTable, REQ
     #ENDBUTTON
   #ENDTAB
  #ENDSHEET
 #ENDBUTTON

#INSERT(%FileControlInitialize(Clarion))
#AT(%CustomGlobalDeclarations)
  #INSERT(%FileControlSetFlags(Clarion))
#ENDAT
#FOR(%LocalData)
%[20]LocalData %LocalDataStatement
#ENDFOR
l:qTable             QUEUE,PRE()
lqTable:Table          STRING(20)
                     END
#WINDOWS
window WINDOW('Tables'),AT(,,143,257),FONT('MS Sans Serif',8,,),SYSTEM,GRAY
       SHEET,AT(2,5,139,250),USE(?Sheet1)
         TAB('Tables'),USE(?Tab1)
           LIST,AT(4,22,134,230),USE(?List),ALRT(EnterKey),ALRT(MouseLeft2),VSCROLL,FORMAT('20L(2)'),FROM(l:qTable)
         END
       END
     END
#ENDWINDOWS

#INSERT(%StandardWindow)
#GROUP(%StandardWindow)
#DECLARE(%FirstField)
#DECLARE(%LastField)

#IF(NOT %Window)
  #ERROR(%Procedure & ' Error: No Window Defined!')
  #RETURN
#ENDIF
#INSERT(%StandardWindowGeneration)
#!
#EMBED(%DataSection,'Data Section'),DATA
  CODE
#EMBED(%StartOfProcedure,'Start of Procedure')
  free(l:qTable)
 #FOR(%File)
   #FIND (%ExclTable, %File)
   #IF (%ExclTable)
     #CYCLE
   #ENDIF
  lqTable:Table = '%File';   add(l:qTable)
 #ENDFOR
#EMBED(%EndOfProcedure,'Before Window Open')
  a# = 0
  sort(l:qTable,+lqTable:Table)
  open(%Window)
  l:qTable = pTable
  accept
    if event() = event:alertkey then
      get(l:qTable,choice(?List))
      a# = 1
      break
    end
  end
  close(%Window)
  if a# = 1 then
    return(lqTable:Table)
  else
    return(pTable)
  end
#EMBED(%EndOfProcedure,'End of Procedure')


#! ####################################################################################################
#! ####################################################################################################
